#include <stdio.h>

#define N 1000000

int initcell(int, float);
 
int cn[N+2],cnminus1[N+2]; 

int main(int argc, char **argv){

  int i, iter, nmove, ncars, icell, cellval; 
  int maxiter, printfreq; 

  float  density, rng; 
  double begin, end;

  maxiter = 2000000000/N; 
  printfreq = maxiter/10; 

  // Set target density of cars

  density = 0.712;

  printf("Length of road is %d\n", N);
  printf("Number of iterations is %d \n", maxiter);
  printf("Target density of cars is %f \n", density);

  // Initialise road accordingly using random number generator

  printf("Initialising ...\n");
  
  ncars = 0;

  // Set the value based on the global cell number for reproducibility   
  for (i=1; i<=N; i++) {
    cnminus1[i] = initcell(i,density); 
    ncars += cnminus1[i]; 
  } 

  printf("...done\n\n");
  
  printf("Actual density of cars is %f\n", (float) ncars / (float) N);

  for (iter=1; iter<=maxiter; iter++) { 

    nmove = 0; 

    cnminus1[0]   = cnminus1[N];
    cnminus1[N+1] = cnminus1[1];

    // Apply CA rules to all cells

    for (i=1; i<=N; i++) {
	
      if (cnminus1[i] == 1) {
 
	if (cnminus1[i+1] == 1) {
	  cn[i] = 1;  
	}
	else {
	  cn[i] = 0; 
	  nmove++; 
	}
      }
      else {

	if (cnminus1[i-1] == 1) { 
	  cn[i] = 1;  
	}
	else {
	  cn[i] = 0; 
	}

      }

    }

    // Copy new to old array

    for (i=1; i<=N; i++) {
      cnminus1[i] = cn[i]; 
    }

    if (iter%printfreq == 0) {

      printf("At iteration %d average velocity is %f \n", iter, (float) nmove / (float) ncars);
    } 

  }

}


int initcell(int index, float density) { 

  int i;
  long long res,aa,mm; 
  float rng;

  aa = 16807; 
  mm = 2147483647;
 
  res = index*aa; 
  for (i=0; i<20; i++) {
    res = (res*aa)%mm;
  }
  rng = (float) res/ (float) mm; 

  if (rng < density) {
    return(1);
  } 
  else {
    return(0);
  }
 
} 
